"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.builder = builder;
var websocketServer_1 = require("./websocketServer");
var esbuild_1 = require("esbuild");
var chokidar_1 = __importDefault(require("chokidar"));
var log_1 = require("./log");
var events_1 = require("./events");
var runNodeApp_1 = require("./runNodeApp");
var runElectronApp_1 = require("./runElectronApp");
function builder(type, config, esbuildConfig) {
    return __awaiter(this, void 0, void 0, function () {
        // internal console log printer
        function logMsg(msg) {
            (0, log_1.log)(type, msg);
        }
        // internal console log printer
        function logBuildDone() {
            logMsg("build done: ".concat((esbuildConfig === null || esbuildConfig === void 0 ? void 0 : esbuildConfig.outfile) || (esbuildConfig === null || esbuildConfig === void 0 ? void 0 : esbuildConfig.outdir)));
        }
        function buildError(error) {
            logMsg("esbuild failed" + (config === null || config === void 0 ? void 0 : config.printBuildError) &&
                (config === null || config === void 0 ? void 0 : config.printBuildError) === true
                ? error
                : "");
        }
        // helper for rebuilder
        function makeBuilder(dev) {
            return __awaiter(this, void 0, void 0, function () {
                var e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 6, , 7]);
                            if (!dev) return [3 /*break*/, 3];
                            return [4 /*yield*/, (0, esbuild_1.context)(esbuildConfig)];
                        case 1:
                            builder = _a.sent();
                            return [4 /*yield*/, builder.rebuild()];
                        case 2:
                            _a.sent();
                            return [3 /*break*/, 5];
                        case 3: return [4 /*yield*/, (0, esbuild_1.build)(esbuildConfig)];
                        case 4:
                            builder = _a.sent();
                            _a.label = 5;
                        case 5: return [3 /*break*/, 7];
                        case 6:
                            e_1 = _a.sent();
                            buildError(e_1);
                            return [3 /*break*/, 7];
                        case 7: return [2 /*return*/];
                    }
                });
            });
        }
        var childSpawn, builder;
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, makeBuilder((config === null || config === void 0 ? void 0 : config.watch) !== undefined)];
                case 1:
                    _a.sent();
                    logBuildDone();
                    if (config && config.watch) {
                        chokidar_1.default.watch(config.watch, {}).on("change", function (eventName, path) { return __awaiter(_this, void 0, void 0, function () {
                            var msg;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        msg = "file changed ".concat(eventName);
                                        logMsg(msg);
                                        if (!(!builder && config.watch)) return [3 /*break*/, 2];
                                        return [4 /*yield*/, makeBuilder(config.watch !== undefined)];
                                    case 1:
                                        _a.sent();
                                        _a.label = 2;
                                    case 2:
                                        // rebuild only be if incremental config
                                        if (builder && builder.rebuild) {
                                            // incremental build
                                            return [2 /*return*/, builder
                                                    .rebuild()
                                                    .then(function () {
                                                    logBuildDone();
                                                    if (childSpawn) {
                                                        logMsg("killing app");
                                                        childSpawn.kill("SIGINT");
                                                    }
                                                    if (esbuildConfig.outfile && config.launch && type === "NODEJS") {
                                                        childSpawn = (0, runNodeApp_1.runNodeApp)(esbuildConfig.outfile, config.launchArg, function (msg) {
                                                            logMsg(msg);
                                                        });
                                                    }
                                                    if (esbuildConfig.outfile && config.launch && type === "ELECTRON") {
                                                        childSpawn = (0, runElectronApp_1.runElectronApp)(esbuildConfig.outfile, config.launchArg, function (msg) {
                                                            logMsg(msg);
                                                        });
                                                    }
                                                    if (config.transmitt) {
                                                        (0, events_1.publish)(config.transmitt);
                                                    }
                                                    (0, websocketServer_1.callWebsocketClient)(msg);
                                                })
                                                    .catch(function (e) {
                                                    // if this break then reset rebuild option
                                                    buildError(e);
                                                    builder = null;
                                                })];
                                        }
                                        else {
                                            // no increment, then we just build it
                                            return [2 /*return*/, (0, esbuild_1.build)(esbuildConfig)
                                                    .then(function () {
                                                    logBuildDone();
                                                    if (config.transmitt) {
                                                        (0, events_1.publish)(config.transmitt);
                                                    }
                                                })
                                                    .catch(function (e) {
                                                    buildError(e);
                                                })];
                                        }
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                    }
                    if (esbuildConfig.outfile && config && config.launch && type === "NODEJS") {
                        childSpawn = (0, runNodeApp_1.runNodeApp)(esbuildConfig.outfile, config.launchArg, function (msg) {
                            logMsg(msg);
                        });
                    }
                    if (esbuildConfig.outfile && config && config.launch && type === "ELECTRON") {
                        childSpawn = (0, runElectronApp_1.runElectronApp)(esbuildConfig.outfile, config.launchArg, function (msg) {
                            logMsg(msg);
                        });
                    }
                    if (config === null || config === void 0 ? void 0 : config.listen) {
                        (0, events_1.subscribe)(config.listen, function () {
                            return __awaiter(this, void 0, void 0, function () {
                                var msg;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            msg = "subscribe event ".concat(config.listen);
                                            logMsg(msg);
                                            if (!(!builder && config.watch)) return [3 /*break*/, 2];
                                            return [4 /*yield*/, makeBuilder(config.watch !== undefined)];
                                        case 1:
                                            _a.sent();
                                            _a.label = 2;
                                        case 2:
                                            if (builder && builder.rebuild) {
                                                // incremental build
                                                builder
                                                    .rebuild()
                                                    .then(function () {
                                                    logBuildDone();
                                                    (0, websocketServer_1.callWebsocketClient)(msg);
                                                    if (config.transmitt) {
                                                        (0, events_1.publish)(config.transmitt);
                                                    }
                                                })
                                                    .catch(function (e) {
                                                    buildError(e);
                                                    builder = null;
                                                });
                                            }
                                            else {
                                                // normal build
                                                (0, esbuild_1.build)(esbuildConfig)
                                                    .then(function () {
                                                    logBuildDone();
                                                    (0, websocketServer_1.callWebsocketClient)(msg);
                                                    if (config.transmitt) {
                                                        (0, events_1.publish)(config.transmitt);
                                                    }
                                                })
                                                    .catch(function (e) {
                                                    buildError(e);
                                                });
                                            }
                                            return [2 /*return*/];
                                    }
                                });
                            });
                        });
                    }
                    return [2 /*return*/];
            }
        });
    });
}
//# sourceMappingURL=builder.js.map