"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.runNodeApp = runNodeApp;
var child_process_1 = require("child_process");
function runNodeApp(launchJs, nodeArgs, msgCallback) {
    if (nodeArgs === void 0) { nodeArgs = {}; }
    var args = [launchJs];
    if (nodeArgs && nodeArgs.argsBefore) {
        args = nodeArgs.argsBefore.concat(args);
    }
    if (nodeArgs && nodeArgs.argsBefore) {
        args = args.concat(nodeArgs.argsBefore);
    }
    msgCallback("staring app, argsbefore:".concat(nodeArgs === null || nodeArgs === void 0 ? void 0 : nodeArgs.argsBefore, ", argsafter:").concat(nodeArgs === null || nodeArgs === void 0 ? void 0 : nodeArgs.argsAfter));
    var childSpawn = (0, child_process_1.spawn)("node", args, {
        stdio: "inherit",
        cwd: process.cwd(),
        env: process.env,
    }).on("exit", function (code) {
        msgCallback("app exit:".concat(code || ""));
    });
    return childSpawn;
}
//# sourceMappingURL=runNodeApp.js.map