"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.inspectCode = inspectCode;
var ts = __importStar(require("typescript"));
var getOptionsDiagnostics_1 = require("./getOptionsDiagnostics");
var getGlobalDiagnostics_1 = require("./getGlobalDiagnostics");
var getSyntacticDiagnostics_1 = require("./getSyntacticDiagnostics");
var getSemanticDiagnostics_1 = require("./getSemanticDiagnostics");
var throwIfErrors_1 = require("./throwIfErrors");
function inspectCode(options, oldProgram) {
    var parseConfigHost = {
        fileExists: ts.sys.fileExists,
        readDirectory: ts.sys.readDirectory,
        readFile: ts.sys.readFile,
        useCaseSensitiveFileNames: true
    };
    var inspectionTimeStart = new Date().getTime();
    var parsed = ts.parseJsonConfigFileContent(options.tsConfigJsonContent, parseConfigHost, options.basePath || '.', undefined);
    var host = ts.createIncrementalCompilerHost(parsed.options);
    var program = ts.createEmitAndSemanticDiagnosticsBuilderProgram(parsed.fileNames, parsed.options, host, oldProgram, undefined, parsed.projectReferences);
    var results = {
        oldProgram: program,
        optionsErrors: (0, getOptionsDiagnostics_1.getOptionsDiagnostics)(options, program),
        globalErrors: (0, getGlobalDiagnostics_1.getGlobalDiagnostics)(options, program),
        syntacticErrors: (0, getSyntacticDiagnostics_1.getSyntacticDiagnostics)(options, program),
        semanticErrors: (0, getSemanticDiagnostics_1.getSemanticDiagnostics)(options, program),
        elapsedInspectionTime: new Date().getTime() - inspectionTimeStart
    };
    (0, throwIfErrors_1.throwIfError)(options, results);
    return results;
}
//# sourceMappingURL=inspectCode.js.map