"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.printSettings = printSettings;
var getPath_1 = require("./getPath");
var logger_1 = require("./logger");
function printSettings(options) {
    // configuration name
    logger_1.Logger.info('');
    logger_1.Logger.info("".concat(logger_1.C_Blue, "Typechecker settings - name:"), logger_1.C_Gray, options.name, logger_1.C_Reset);
    // base path being used
    logger_1.Logger.info("".concat(logger_1.C_Blue, "Typechecker settings - basepath:"), logger_1.C_Gray, options.basePath, logger_1.C_Reset);
    // get tsconfig path and options
    if (options.tsConfig) {
        var tsconf = (0, getPath_1.getPath)(options.tsConfig, options);
        logger_1.Logger.info("".concat(logger_1.C_Blue, "Typechecker settings - tsconfig:"), logger_1.C_Gray, tsconf, logger_1.C_Reset);
    }
    else {
        logger_1.Logger.info("".concat(logger_1.C_Blue, "Typechecker settings - tsconfig:"), logger_1.C_Gray, "undefined, using ts defaults/override if defined", logger_1.C_Reset);
    }
}
//# sourceMappingURL=printSettings.js.map