"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.processTsDiagnostics = processTsDiagnostics;
var interfaces_1 = require("./interfaces");
var ts = __importStar(require("typescript"));
function processTsDiagnostics(_options, errors) {
    return errors.globalErrors
        .concat(errors.semanticErrors)
        .concat(errors.syntacticErrors)
        .concat(errors.optionsErrors)
        .filter(function (diag) { return diag.file; })
        .map(function (diag) {
        // set color from options
        var _a = diag.file.getLineAndCharacterOfPosition(diag.start), line = _a.line, character = _a.character;
        return {
            fileName: diag.file.fileName,
            line: line + 1, // `(${line + 1},${character + 1})`,
            message: ts.flattenDiagnosticMessageText(diag.messageText, interfaces_1.END_LINE),
            char: character + 1,
            color: 'red',
            category: "".concat(ts.DiagnosticCategory[diag.category], ":"),
            code: "TS".concat(diag.code)
        };
    });
}
//# sourceMappingURL=processTsDiagnostics.js.map