"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.throwIfError = throwIfError;
var printResult_1 = require("./printResult");
var logger_1 = require("./logger");
function throwIfError(options, errors) {
    switch (true) {
        // if throwError is set then callback and quit
        case options.throwOnGlobal && errors.globalErrors.length > 0:
        case options.throwOnOptions && errors.optionsErrors.length > 0:
        case options.throwOnSemantic && errors.semanticErrors.length > 0:
        case options.throwOnSyntactic && errors.syntacticErrors.length > 0:
            logger_1.Logger.info("".concat(logger_1.C_Black + logger_1.C_BgYellow, " WARNING ").concat(logger_1.C_Reset + logger_1.C_Yellow, " Typechecker throw on error activated- quitting>"), logger_1.C_Reset);
            (0, printResult_1.printResult)(options, errors);
            process.exit(1);
            break;
    }
}
//# sourceMappingURL=throwIfErrors.js.map