"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.watchSrc = watchSrc;
var chokidar = __importStar(require("chokidar"));
var getPath_1 = require("./getPath");
var debugPrint_1 = require("./debugPrint");
var logger_1 = require("./logger");
var watchTimeout;
function watchSrc(pathToWatch, options, callback) {
    (0, debugPrint_1.debugPrint)("watchSrc" + pathToWatch);
    var basePath;
    if (Array.isArray(pathToWatch)) {
        basePath = pathToWatch.map(function (p) { return (0, getPath_1.getPath)(p, options); });
    }
    else {
        basePath = (0, getPath_1.getPath)(pathToWatch, options);
    }
    //let basePath = getPath(pathToWatch, options);
    var watch = chokidar.watch(basePath);
    // todo-> move into thread
    // tell user what path we are watching
    if (options.print_watchStarted) {
        logger_1.Logger.info("".concat(logger_1.C_Yellow, "\nTypechecker watch mode activated: ").concat(logger_1.C_Reset));
    }
    var ready = false;
    watch.on("ready", function (f /*, stat: any*/) {
        ready = true;
    });
    // on created file event
    watch.on("add", function (f /*, stat: any*/) {
        if (ready) {
            logger_1.Logger.info("".concat(logger_1.C_Yellow, "\nFile created: ").concat(logger_1.C_Gray).concat(f));
            callback();
        }
    });
    // on changed file event
    watch.on("change", function (f /*, curr: any, prev: any*/) {
        // tell user about event
        logger_1.Logger.info("".concat(logger_1.C_Yellow, "\nFile changed: ").concat(logger_1.C_Gray).concat(f));
        // have inside timeout, so we only run once when multiple files are saved
        clearTimeout(watchTimeout);
        watchTimeout = setTimeout(function () {
            callback();
        }, 100);
    });
    watch.on("unlink", function (f /*, stat: any*/) {
        // tell user about event
        logger_1.Logger.info("".concat(logger_1.C_Yellow, "\nFile removed: ").concat(logger_1.C_Gray).concat(f));
        logger_1.Logger.info("Calling typechecker", logger_1.C_Reset);
        // have inside timeout, so we only run once when multiple files are saved
        clearTimeout(watchTimeout);
        watchTimeout = setTimeout(function () {
            callback();
        }, 100);
    });
}
//# sourceMappingURL=watchSrc.js.map