"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var interfaces_1 = require("./interfaces");
var inspectCode_1 = require("./inspectCode");
var printResult_1 = require("./printResult");
var watchSrc_1 = require("./watchSrc");
var printSettings_1 = require("./printSettings");
var debugPrint_1 = require("./debugPrint");
var lastResult;
var printErrorTotal;
// listen for messages
process.on('message', function (msg) {
    (0, debugPrint_1.debugPrint)("worker message recived ".concat(msg.type));
    switch (msg.type) {
        // tell checker to inspect code
        case interfaces_1.WorkerCommand.inspectCode:
            (0, debugPrint_1.debugPrint)('worker inspectCode');
            if (msg.options) {
                lastResult = (0, inspectCode_1.inspectCode)(msg.options, lastResult && lastResult.oldProgram);
            }
            else {
                throw new Error('You tried to inspect code without ts/lint options');
            }
            break;
        // tell checker to inspect code
        case interfaces_1.WorkerCommand.inspectCodeAndPrint:
            (0, debugPrint_1.debugPrint)('worker inspectCodeAndPrint');
            if (msg.options) {
                lastResult = (0, inspectCode_1.inspectCode)(msg.options, lastResult && lastResult.oldProgram);
                printErrorTotal = (0, printResult_1.printResult)(msg.options, lastResult);
                printErrorTotal = printErrorTotal;
            }
            else {
                throw new Error('You tried to inspect code without ts/lint options');
            }
            break;
        case interfaces_1.WorkerCommand.printResult:
            (0, debugPrint_1.debugPrint)('worker printResult');
            if (msg.options && lastResult) {
                printErrorTotal = (0, printResult_1.printResult)(msg.options, lastResult);
            }
            else {
                throw new Error('You tried to print code without ts/lint options or without having inspected code');
            }
            break;
        case interfaces_1.WorkerCommand.printSettings:
            (0, debugPrint_1.debugPrint)('worker printSettings');
            if (msg.options) {
                (0, printSettings_1.printSettings)(msg.options);
            }
            else {
                throw new Error('You tried to print settings without ts/lint options or without having inspected code');
            }
            break;
        case interfaces_1.WorkerCommand.watch:
            (0, debugPrint_1.debugPrint)('worker watch');
            if (msg.options) {
                (0, watchSrc_1.watchSrc)(msg.pathToWatch, msg.options, function () {
                    lastResult = (0, inspectCode_1.inspectCode)(msg.options, lastResult && lastResult.oldProgram);
                    printErrorTotal = (0, printResult_1.printResult)(msg.options, lastResult);
                });
            }
            else {
                throw new Error('You tried to print code without ts/lint options or without having inspected code');
            }
            break;
    }
});
(0, debugPrint_1.debugPrint)('worker started');
//# sourceMappingURL=worker.js.map