"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.startDevServer = startDevServer;
var express_1 = __importDefault(require("express"));
var zlib = require('node:zlib');
var log_1 = require("./log");
var compression;
try {
    compression = require("compression");
}
catch (err) { }
function startDevServer(port, distFolder, publicFolders, host) {
    var app = (0, express_1.default)();
    if (compression) {
        app.use(compression({
            threshold: 1,
            flush: zlib.constants.Z_SYNC_FLUSH,
        }));
    }
    if (Array.isArray(publicFolders)) {
        publicFolders.forEach(function (folder) {
            app.use(express_1.default.static(folder, {
                etag: false,
                maxAge: "5",
            }));
        });
    }
    app.use(express_1.default.static(distFolder, {
        etag: false,
        maxAge: "5",
    }));
    app.listen(port, function () {
        (0, log_1.log)("DEVSERVER", "http://".concat(host || "localhost", ":") + port);
        (0, log_1.log)("DEVSERVER", "path: ".concat(distFolder, ":"));
    });
}
//# sourceMappingURL=webDevServer.js.map