"use strict";
/**
 * Creates web socket server
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.startWebsocketServer = startWebsocketServer;
exports.callWebsocketClient = callWebsocketClient;
var ws_1 = __importDefault(require("ws"));
var log_1 = require("./log");
var webSocketServerInstance = null;
var connections = new Set();
/**
 * Start server
 * @param port
 */
function startWebsocketServer(port) {
    webSocketServerInstance = new ws_1.default.Server({ port: port });
    webSocketServerInstance.on("connection", function connection(wsConnection) {
        (0, log_1.log)("WEBSOCKET", "client connected");
        connections.add(wsConnection);
    });
    webSocketServerInstance.on("close", function close(wsConnection) {
        (0, log_1.log)("WEBSOCKET", "client disconnected");
        connections.delete(wsConnection);
    });
}
function callWebsocketClient(msg) {
    (0, log_1.log)("WEBSOCKET", "client update call");
    Array.from(connections).forEach(function (wsConnection) {
        wsConnection.send(msg);
    });
}
//# sourceMappingURL=websocketServer.js.map